/*
 *  Copyright (C) 2010  Thadeu Lima de Souza Cascardo <cascardo@holoscopio.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */


#include <linux/module.h>
#include <linux/moduleparam.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/slab.h>

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Thadeu Lima de Souza Cascardo <cascardo@holoscopio.com>");
MODULE_DESCRIPTION("Hello, world");

struct hello {
	int times;
	char greeting[0];
};

static struct hello *hello;

static char default_greeting[] = "Hello, world!\n";

static int hello_init(void)
{
	hello = kmalloc(sizeof(*hello) + sizeof(default_greeting), GFP_KERNEL);
	if (!hello)
		return -ENOMEM;
	memcpy(hello->greeting, default_greeting, sizeof(default_greeting));
	printk("%s\n", hello->greeting);
	printk("%p %p %p\n", hello, hello->greeting,
		container_of(&hello->greeting, struct hello, greeting));
	printk("size %d\n", ARRAY_SIZE(default_greeting));
	return 0;
}

static __exit void hello_exit(void)
{
	kfree(hello);
}

module_init(hello_init);
module_exit(hello_exit);
